import java.io.*;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.naming.directory.InitialDirContext;
import javax.naming.Context;

import org.xml.sax.InputSource;
import org.exolab.castor.dsml.Importer;
import org.exolab.castor.dsml.jndi.JNDIImporter;
import org.exolab.castor.dsml.tools.PrintImportListener;

import netscape.ldap.LDAPConnection;

public class CreateGroup extends HttpServlet
{
  InitialDirContext ctx;
  public void init()
  {
      LDAPConnection conn;
      Hashtable env;

      try
      {
        //connect to LDAP Server
        env = new Hashtable();
        env.put(Context.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.ldap.LdapCtxFactory");
        env.put(Context.SECURITY_AUTHENTICATION, "simple");
        env.put(Context.PROVIDER_URL, "ldap://localhost:389");
        env.put(Context.SECURITY_PRINCIPAL, "cn=Directory Manager");
        env.put(Context.SECURITY_CREDENTIALS, "password");
        ctx = new InitialDirContext(env);
      }
      catch(Exception ex)
      {
        ex.printStackTrace();
      }
   }

  public void doPost(HttpServletRequest req, HttpServletResponse res)
  {
    try
    {
        //format parameters into an xml format
        String xml = createXML(req);

        //generate well-formed dsml
        String dsml = createDSML(xml);

        //import into ldap
        Create create = new Create(ctx);
        String importResults = create.doCreate(dsml);

        //show results of the import into Directory Service to user
        PrintWriter out = res.getWriter();
        res.setContentType("text/html");
        out.write(importResults);
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public String createXML(HttpServletRequest req)
  {
      String  name  = new String();
      String[]  value;
      StringBuffer  xmlString = new StringBuffer("<?xml version=\"1.0\"?>");

      xmlString.append("<data>\n");
      Enumeration  htmlParm =   req.getParameterNames();
			//get name-value pairs received from the browser
			while( htmlParm.hasMoreElements() )
			{
				name = ( (String)htmlParm.nextElement() ).trim();
        if ( name != null)
        {
            value = req.getParameterValues(name);
            for( int i=0; value.length > 0 && value.length > i; i++)
            {
              xmlString.append("\t<"+name+">"+value[i]+"</"+name+">\n");
            }
        }
      }
      xmlString.append("</data>");
      return xmlString.toString();
  }
  public String createDSML(String xml)
  {
      XSLUtil xslUtil = new XSLUtil();
      File file = new File("CreateDSML.xsl");
      String dsml = xslUtil.styleXSL(file,xml);
      return dsml;
  }
  public String doCreate(String dsml)
  {
      Importer importer = new JNDIImporter(ctx);
      PrintImportListener printer;
      StringWriter out = new StringWriter();

      try
      {
        StringWriter writer = new StringWriter();
        //set writer
        printer = new PrintImportListener( new PrintWriter( out ) );
        //set event listener
        importer.setImportEventListener( printer );
        //set the import policy
        importer.readImportDescriptor(new FileReader("import.xml"));
        //insert records into LDAP
	      importer.importDocument(new StringReader(dsml));
      }
      catch(Exception e)
      {
        e.printStackTrace();
      }
      return out.toString();
  }
}

