import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.naming.directory.InitialDirContext;
import javax.naming.Context;

import netscape.ldap.LDAPConnection;

import java.util.Hashtable;

import org.exolab.castor.dsml.Exporter;
import org.exolab.castor.dsml.jndi.JNDIExporter;
import org.exolab.castor.dsml.SearchDescriptor;

import RemoveNamespace;

public class DisplayUser extends HttpServlet
{
  InitialDirContext ctx;

  public void init()
  {
      LDAPConnection conn;
      Hashtable env;

      try
      {
        //connect to LDAP Server
        env = new Hashtable();
        env.put(Context.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.ldap.LdapCtxFactory");
        env.put(Context.SECURITY_AUTHENTICATION, "simple");
        env.put(Context.PROVIDER_URL, "ldap://localhost:389");
        env.put(Context.SECURITY_PRINCIPAL, "cn=Directory Manager");
        env.put(Context.SECURITY_CREDENTIALS, "password");
        ctx = new InitialDirContext(env);
      }
      catch(Exception ex)
      {
        ex.printStackTrace();
      }
   }

   public void doPost(HttpServletRequest req, HttpServletResponse res)
   {
      try
      {
        RemoveNamespace remover = new RemoveNamespace();
        Search search = new Search(ctx);
        StringBuffer xsl = new StringBuffer();
        String results = "";
        String dsml = "";

        //get parameters
        String attributeName = req.getParameter("attributeName");
        String searchValue = req.getParameter("searchValue");

        //search directory
        results = search.doSearch(attributeName,searchValue);

        //remove the namespace from dsml
        dsml = remover.remove(results);

        //style search results
        XSLUtil xslUtil = new XSLUtil();
        File file = new File("DisplayUser.xsl");
        String html = xslUtil.styleXSL(file, dsml);

        PrintWriter out = res.getWriter();
        res.setContentType("text/html");
        out.write(html.toString());
      }
      catch(Exception e)
      {
        e.printStackTrace();
      }
   }
   public String doSearch(String attribute, String searchValue)
   {
      Exporter exporter = new JNDIExporter(ctx);
      SearchDescriptor sd = new SearchDescriptor();
      StringWriter writer = new StringWriter();
      try
      {
        //confiqure the search descriptor
        //set the domain name to search
        sd.setBaseDN("o=javaworld.com");
        //set the scope of the search
        sd.setScope(3);  //scope 1 = base, 2 = onelevel, 3 = subtree

        //setFilter for Directory Server
        //in our case the attribute is departmentnumber
        sd.setFilter(attribute+"="+searchValue);

        //assign search descriptor
        exporter.setSearchDescriptor(sd);
        //perform the search of the Directory Server
        exporter.export(writer,false,true);
      }
      catch(Exception e)
      {
        e.printStackTrace();
      }
      //return String (dsml) of search results
      return writer.toString();
   }
}