import java.io.*;

import javax.naming.directory.InitialDirContext;

import org.exolab.castor.dsml.Exporter;
import org.exolab.castor.dsml.jndi.JNDIExporter;
import org.exolab.castor.dsml.SearchDescriptor;

public class Search
{
  Exporter exporter = null;
  SearchDescriptor sd = null;

  public Search(InitialDirContext ctx)
  {
        exporter = new JNDIExporter(ctx);
        sd = new SearchDescriptor();
   }

  public String doSearch(String attribute, String searchValue)
  {
    StringWriter writer = new StringWriter();
    try
    {
        //confiqure the search descriptor
        //set the domain name to search
        sd.setBaseDN("o=javaworld.com");
        //set the scope of the search
        sd.setScope(3);  //scope 1 = base, 2 = onelevel, 3 = subtree

        //setFilter for Directory Server
        //in our case the attribute is departmentnumber
        sd.setFilter(attribute+"="+searchValue);

        //assign search descriptor
        exporter.setSearchDescriptor(sd);
        //perform the search of the Directory Server
        exporter.export(writer,false,true);
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
    //return String (dsml) of search results
    return writer.toString();
  }
}
